"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = _default;

var _lodash = _interopRequireDefault(require("lodash"));

var _webpack = _interopRequireDefault(require("webpack"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _path = _interopRequireDefault(require("path"));

var _chalk = _interopRequireDefault(require("chalk"));

var _webpackDevServer = _interopRequireDefault(require("webpack-dev-server"));

var _opn = _interopRequireDefault(require("opn"));

var _initConfig = _interopRequireDefault(require("../initConfig"));

var _checkDeps = _interopRequireDefault(require("../checkDeps"));

var _printCompileMessages = _interopRequireDefault(require("../utils/printCompileMessages"));

var _webpack2 = _interopRequireDefault(require("../webpack/webpack.config"));

var _createWebpackCompiler = _interopRequireDefault(require("../utils/createWebpackCompiler"));

var _printBuildError = _interopRequireDefault(require("../utils/printBuildError"));

var _logger = _interopRequireDefault(require("../utils/logger"));

function _default(entry, output, opts = {}) {
  const config = (0, _initConfig.default)(entry, output, opts);
  config.assets.css.name = "[name].css";
  config.assets.css.chunkName = "[name].chunk.css";
  config.assets.js.name = "[name].js";
  config.assets.js.chunkName = "[name].chunk.js";
  config.assets.media.name = "[name].[ext]";
  const devServerOptions = config.devServer || {};
  devServerOptions.contentBase = _path.default.resolve(config.cwd, config.outputDir); // let webpackConfig = webpackConfigFactory(config);
  //自定义
  // if (_.isFunction(config.getWebpackConfig)) {
  // 	webpackConfig = config.getWebpackConfig(webpackConfig);
  // }

  _fsExtra.default.ensureDirSync(config.outputDir);

  if (config.clean) {
    _fsExtra.default.emptyDirSync(config.outputDir);
  }

  const url = `${devServerOptions.https ? "https" : "http"}://127.0.0.1:${devServerOptions.port}`;
  const compiler = (0, _createWebpackCompiler.default)(config);
  compiler.hooks.done.tap("done", async stats => {
    const statsData = stats.toJson({
      all: false,
      warnings: true,
      errors: true
    });

    if (!statsData.errors.length) {
      console.log(`  address: ${_chalk.default.underline(url)}`);
      console.log();
    }
  }); //https://webpack.js.org/guides/hot-module-replacement/
  // webpackDevServer.addDevServerEntrypoints(webpackConfig, devServerOptions);

  const server = new _webpackDevServer.default(compiler, devServerOptions);
  server.listen(devServerOptions.port, devServerOptions.host, () => {
    (0, _logger.default)(_chalk.default.cyan("Starting the development server..."));
    (0, _opn.default)(url);
  });
}