"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = _default;

var _path = _interopRequireDefault(require("path"));

var _lodash = _interopRequireDefault(require("lodash"));

var _getWebpackModules = _interopRequireDefault(require("./getWebpackModules"));

var _getWebpackPlugins = _interopRequireDefault(require("./getWebpackPlugins"));

var _getWebpackOptimization = _interopRequireDefault(require("./getWebpackOptimization"));

// import PnpWebpackPlugin from "pnp-webpack-plugin";
function _default(opts) {
  const assetsJs = opts.assets.js;
  const shouldUseSourceMap = opts.shouldUseSourceMap;
  const isEnvProduction = opts.mode === "production";
  const isEnvDevelopment = opts.mode === "development";
  return {
    context: opts.cwd,
    mode: isEnvProduction ? "production" : isEnvDevelopment && "development",
    bail: isEnvProduction,
    devtool: opts.devtool || (isEnvProduction ? shouldUseSourceMap ? "source-map" : false : isEnvDevelopment && "cheap-module-source-map"),
    entry: opts.entry,
    output: _lodash.default.defaultsDeep(opts.output || {}, {
      path: _path.default.resolve(opts.cwd, opts.outputDir),
      filename: [assetsJs.output || ".", assetsJs.name].join("/"),
      chunkFilename: [assetsJs.output || ".", assetsJs.chunkName].join("/"),
      publicPath: opts.publicPath
    }),
    module: (0, _getWebpackModules.default)(opts),
    plugins: (0, _getWebpackPlugins.default)(opts),
    optimization: (0, _getWebpackOptimization.default)(opts),
    externals: opts.externals,
    resolve: Object.assign({
      extensions: [".js", ".jsx", ".mjs", ".ts", ".tsx"]
    }, opts.resolve),
    // resolveLoader: {
    // 	plugins: [PnpWebpackPlugin.moduleLoader(module)],
    // },
    target: opts.target,
    // Some libraries import Node modules but don't use them in the browser.
    // Tell webpack to provide empty mocks for them so importing them works.
    node: {
      module: "empty",
      dgram: "empty",
      dns: "mock",
      fs: "empty",
      http2: "empty",
      net: "empty",
      tls: "empty",
      child_process: "empty"
    },
    // Turn off performance processing because we utilize
    // our own hints via the FileSizeReporter
    // performance: opts.performance,
    performance: false
  };
}